leetcode解题: Assign Cookies (455)

Assume you are an awesome parent and want to give your children some cookies. But, you should give each child at most one cookie. Each child i has a greed factor gi, which is the minimum size of a cookie that the child will be content with; and each cookie j has a size sj. If sj >= gi, we can assign the cookie j to the child i, and the child i will be content. Your goal is to maximize the number of your content children and output the maximum number.

Note:
You may assume the greed factor is always positive.
You cannot assign more than one cookie to one child.

Example 1:
Input: [1,2,3], [1,1]

Output: 1

Explanation: You have 3 children and 2 cookies. The greed factors of 3 children are 1, 2, 3.
And even though you have 2 cookies, since their size is both 1, you could only make the child whose greed factor is 1 content.
You need to output 1.
Example 2:
Input: [1,2], [1,2,3]

Output: 2

Explanation: You have 2 children and 3 cookies. The greed factors of 2 children are 1, 2.
You have 3 cookies and their sizes are big enough to gratify all of the children,
You need to output 2.

解法1:O(nlogn + mlogm) 贪心

如果两个array g和s都是从小到大排序的,那么基本思路就是把满足条件当中最小的一个cookie给孩子,然后再从剩下的cookie中挑选满足条件的最小的cookie给下一个孩子。这似乎就是一种贪心的思路。
排序需要花费O(NlogN)的时间,两个数组分别排序。
排序之后,维护两个指针分别在两个数组。遍历孩子的数组,直到cookie的数组已选完。用到线性的时间。所以整体的复杂度还是O(nlogn)的量级。
C++
用到了std::sort(vector.begin(), vector.end())

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
class Solution {
public:
int findContentChildren(vector<int>& g, vector<int>& s) {
// sort two vectors
std::sort(g.begin(), g.end());
std::sort(s.begin(), s.end());
int gPtr = 0;
int sPtr = 0;
int num = 0;
for (; gPtr < g.size() && sPtr < s.size(); ++gPtr) {
while (sPtr < s.size() && s[sPtr] < g[gPtr]) ++sPtr;
if (sPtr == s.size()) break;
++num;
++sPtr;
}
return num;
}
};

Java

1